<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPoolPlugin\Provider;

use Dedi\SyliusCustomerPoolPlugin\Model\Customer\CustomerPoolAwareInterface;
use Dedi\SyliusCustomerPoolPlugin\Repository\UserWithCustomerPoolRepositoryInterface;
use Sylius\Bundle\UserBundle\Provider\AbstractUserProvider;
use Sylius\Component\Channel\Context\ChannelContextInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use Webmozart\Assert\Assert;

class EmailAndCustomerPoolProvider extends AbstractUserProvider
{
    /** @var ChannelContextInterface */
    private $channelContext;

    public function setChannelContext(ChannelContextInterface $channelContext)
    {
        $this->channelContext = $channelContext;
    }

    protected function findUser(string $uniqueIdentifier): ?UserInterface
    {
        /** @var ChannelContextInterface|CustomerPoolAwareInterface $channel */
        $channel = $this->channelContext->getChannel();

        Assert::isInstanceOf($this->userRepository, UserWithCustomerPoolRepositoryInterface::class);

        /** @var UserWithCustomerPoolRepositoryInterface $repository */
        $repository = $this->userRepository;

        return $repository->findOneByEmailAndCustomerPool($uniqueIdentifier, $channel->getCustomerPool());
    }
}
